module.exports = function(grunt) {

  // Project configuration.
  grunt.initConfig({
    shell: {
      startServerWin: {
        command: 'set DEBUG=web_panel & node ./web_panel/bin/www'
      },
      startServer: {
        command: 'DEBUG=web_panel ./web_panel/bin/www'
      },
      mongodbRun: {
        command: 'cd "C:/Program Files/MongoDB 2.6 Standard/bin/" & mongod.exe --dbpath "C:/Program Files/MongoDB 2.6 Standard/data/db"'
      }
    },
    bower: {
      install: {
        options: {
          targetDir: './public/vendor',
          layout: 'byComponent',
          install: true,
          cleanBowerDir: true,          
          verbose: true,
          copy: true          
        }
      }      
    }
  });

  // Load the plugin that provides the "uglify" task.
  grunt.loadNpmTasks('grunt-shell');
  grunt.loadNpmTasks('grunt-bower-task');

  // Default task(s).
  grunt.registerTask('default', []);

  //custom tasks
  grunt.registerTask('bower:update', ['bower']);
  grunt.registerTask('debug', ['shell:startServer']);
  grunt.registerTask('debug:win', ['shell:startServerWin']);
  grunt.registerTask('mongodb:run', ['shell:mongodbRun']);

};