var console = require('console'),
    events  = require('events'),
    fs      = require('fs'),
    validator = require('../../node_modules/validator');

var resp, log_level,
    emiter = new events.EventEmitter(),
    loader, Route;

/*function createServer(){
    var http = require('http'),
        console = require('console');

    var server = http.createServer(function(request, response) {
        logger({type: 'client.connected', module: 'comunicator', date: new Date().toUTCString()});
        var matched = false,
            i = 0;
        if(request.url == '/fabicon.ico'){
            response.write('Not found');
            response.end();
            matched = true;
        }
        while(i < routes.length && !matched){
            var req_url = false;
            if(routes[i].prefix.indexOf(':')>0){
                var regex = new RegExp('/'+routes[i].type+'/\\d+');
                if(regex.test(request.url)){
                    req_url = true;
                }
            }else{
                if(routes[i].prefix == request.url){
                    req_url = true;
                }
            }
            if(routes[i].VERB == request.method && req_url){
                //response.write(JSON.stringify({state: 'ok'}));
                //var ee = new events.EventEmitter();
                req = request;
                resp = response;
                matched = true;

                emiter.emit('api.action.'+routes[i].type+'.'+routes[i].VERB, request);
                logger({type: 'api.action.'+routes[i].type, module: 'comunicator', date: new Date().toUTCString()});

                var fullBody = '';
                request.on('data', function(chunk){
                    fullBody += chunk.toString();
                });

                request.on('end', function(){
                    if(validator.isJSON(fullBody)){
                        process.emit("data.end", {req : request, route: routes[i], data: fullBody});
                        logger({type: 'data.end', module: 'comunicator', date: new Date().toUTCString()});
                        process.nextTick(
                            function(){
                                process.emit('log', {type: 'api.action', module: 'comunicator', date: new Date().toUTCString()});
                            }
                        );
                    }
                });
            }
            i = i + 1;
        }
    });
    logger({type: 'server.created', module: 'comunicator', date: new Date().toUTCString()});
    server.listen(80);
    logger({type: 'server.listen', module: 'comunicator', date: new Date().toUTCString()});
}*/

function createServer(){
    var http = require('http'),
        console = require('console');

    var server = http.createServer(function(request, response) {
        logger({type: 'client.connected', module: 'comunicator', date: new Date().toUTCString()});
        if(request.url == '/fabicon.ico'){
            response.write('Not found');
            response.end();
        }else{
            var url = request.url;
            if(new RegExp('[0-9]$').test(request.url)){
                url = request.url.substr(0, request.url.lastIndexOf('/')+1) + ':id';
            }
            resp = response;
            Route.findOne({verb: request.method, prefix: url}, function(err, doc){
                if(err){
                    return console.error(err);
                }

                emiter.emit('api.action.'+doc.type+'.'+doc.verb, request);
                logger({type: 'api.action.'+doc.type+'/'+doc.name, module: 'comunicator', date: new Date().toUTCString()});

                var fullBody = '';
                request.on('data', function(chunk){
                    fullBody += chunk.toString();
                });

                request.on('end', function(){
                    if(validator.isJSON(fullBody)){
                        process.emit("data.end", {req : request, route: matchedRoute, data: fullBody});
                        logger({type: 'data.end', module: 'comunicator', date: new Date().toUTCString()});
                        process.nextTick(
                            function(){
                                process.emit('log', {type: 'api.action', module: 'comunicator', date: new Date().toUTCString()});
                            }
                        );
                    }
                });
            });
        }
    });
    logger({type: 'server.created', module: 'comunicator', date: new Date().toUTCString()});
    server.listen(80);
    logger({type: 'server.listen', module: 'comunicator', date: new Date().toUTCString()});
}

function logger(params){
    if(log_level == 'ALL'){
        console.info(JSON.stringify(params));
    }
}

emiter.on('api.action.job.PUT', function(data){

});

emiter.on('api.action.job.PATCH', function(data){

});

emiter.on('api.action.job.DELETE', function(data){

});

function loadConfigRouting(config){
    var routes = [];
    for(var i = 0; i < config.routes.length; i++){
        var type = config.routes[i].type;
        var prefix = config.routes[i].prefix;
        for(var j = 0; j < config.routes[i].actions.length; j++){
            var route = new Object();
            route.type = type;
            route.prefix = prefix + config.routes[i].actions[j].uri;
            route.VERB = config.routes[i].actions[j].VERB;
            route.name = config.routes[i].actions[j].name;
            routes.push(route);
        }
    }
//    logger({type: 'config.routing.loaded', module: 'comunicator', date: new Date().toUTCString()});
    return routes;
}

function loadConfigFromFile(path){
    logger({type: 'config.load.file', module: 'comunicator', date: new Date().toUTCString()});
    return JSON.parse(fs.readFileSync(path));
}

function send(data){
    logger({type: 'api.response', module: 'comunicator', date: new Date().toUTCString()});
    resp.write(JSON.stringify(data));
    resp.end();
}

function installConfig(mongoose, routes){

    for(var i = 0; i < routes.length; i++){
        var routeModel = new Route({type: routes[i].type, prefix: routes[i].prefix, verb: routes[i].VERB, name: routes[i].name});
        routeModel.save(function (err) {
            if(err){
                console.info('ERROR');
            }
        });
    }

    logger({type: 'config.routing.loaded', module: 'comunicator', date: new Date().toUTCString()});
}

module.exports = {
    create: function(params){
        if(params !== undefined && params.loader !== undefined && params.mongoose !== undefined){
            if(params.log_level === undefined){
                params.log_level = 'ALL';
            }
            log_level = params.log_level;
            loader = params.loader;
            params.mongoose.model('Route', loader.loadByModuleName('schema','Route'));
            Route = params.mongoose.model('Route');
            logger({type: 'module.log.level', value: log_level, module: 'comunicator', date: new Date().to});
            createServer();
            logger({type: 'module.success', module: 'comunicator', date: new Date().toUTCString()});
        }
    },
    install: function(params){
        if(params !== undefined && params.mongoose !== undefined && params.configFile !== undefined && params.loader){
            params.mongoose.model('Route', params.loader.loadByModuleName('schema','Route'));
            Route = params.mongoose.model('Route');
            var config = loadConfigFromFile(params.configFile);
            var routes = loadConfigRouting(config);
            installConfig(params.mongoose, routes);
        }
    },
    send: function(data){
        send(data);
    }
}