//####### Example of bot file ##########

//Modules
/*var fs = require('fs'),
    path = require('path'),
    console = require('console'),
    configuration = require('./modules/configuration'),
    events = require('events').EventEmitter,
    mongoose = require('mongoose'),
    loader = require('./modules/loader');
*/


/*
var ee = new events();
mongoose.connect('mongodb://localhost/bot');

//location of config file loaded from global config
configuration.create({loader: loader, mongoose: mongoose});

//configuration.install({mongoose: mongoose, configFile: process.cwd()+'/config/bot.json', loader: loader});

//New api action invoked
process.addListener('api.action', function (data) {
    console.info('action detected');
    ee.emit(data.route.type, data);
});

process.addListener('log', function(data){
    console.info(JSON.stringify(data));
});

//Events for routes
ee.on('job', function(data){
    //configuration.send(JSON.stringify({type: 'job', status: 'ok'}));
    var parsed = JSON.parse(data.data);
    configuration.send(JSON.stringify({type: 'job', status: 'ok'}));
});

ee.on('config', function(data){
    configuration.send(JSON.stringify({type: 'config', status: 'ok'}));
});

ee.on('extra', function(data){
    configuration.send(JSON.stringify({type: 'extra', status: 'ok'}));
});
*/
/*var db = mongoose.connection;
db.on('error', console.error.bind(console, 'connection error:'));
db.once('open', function (callback) {
    var Route = mongoose.model('Route', require('./schema/route'));
    var route = new Route({type: 'asd', prefix: 'ss', verb: 'ss', name: 'ss'});
    route.save(function (err) {
        if(err){
            console.info('ERROR');
        }
    });
});*/

var fs             = require('fs'),
    _route_manager = {},
    _global_config,
    _task_loader,
    _tasks = [],
    date           = new Date();

//LOAD THE LOG_MANAGER
var _log_manager   = require('./models/log')();

if(_log_manager === undefined){
    return;
}

//LOAD THE GLOBAL CONFIG
try{
    _global_config = JSON.parse(fs.readFileSync('./config/config.json'));
    _log_manager.create({message: "Configuration loaded successful", date: date.getDate()+'/'+date.getMonth()+'/'+date.getFullYear(), type: "info"});
}catch(ex){
    _log_manager.create({message: ex, date: date.getDate()+'/'+date.getMonth()+'/'+date.getFullYear(), type: "error"});
}

//LOAD ROUTE_MANAGER
try{
    fs.readdirSync('./config/routes/').forEach(function(element, index){
        "use strict";
        var conf = {file: element};
        if(_global_config.route_dir !== undefined){
            conf.dir = _global_config.route_dir;
        }
        _route_manager[element.substr(0, element.lastIndexOf('.'))] = require('./models/route')(conf);
        _log_manager.create({message: "All routes loaded successful", date: date.getDate()+'/'+date.getMonth()+'/'+date.getFullYear(), type: "info"});
    });
}catch(ex){
    _log_manager.create({message: ex, date: date.getDate()+'/'+date.getMonth()+'/'+date.getFullYear(), type: "error"});
}

//Load task_manager
_task_loader = require('./models/task')({dir: _global_config.task_dir});
if(_task_loader !== undefined){
    _log_manager.create({message: "All tasks loaded successful", date: date.getDate()+'/'+date.getMonth()+'/'+date.getFullYear(), type: "info"});
}else{
    _log_manager.create({message: "All tasks loaded successful", date: date.getDate()+'/'+date.getMonth()+'/'+date.getFullYear(), type: "error"});
}

/*
 * #### APP MODULES ####
 */
var _server         = require('./modules/server')({receive: onIncomingRequest, send: sendResponse}),
    _crypto         = require('./modules/crypto')({password: _global_config.security.cipher.password}),
    _scheduler      = require('./modules/scheduler'),
    _communication  = require('./modules/communication')();


//init all tasks
_task_loader.read().forEach(function(element, index){
    "use strict";
    var task = _task_loader.read({uid: element});
    var instance = require(task.path + task.file)({
        'instance': task,
        'start' : handleTaskStart,
        'end': handleTaskEnd,
        'error': handleTaskError,
        'communicate': handleTaskCommunicate,
        'notify': handleTaskNotify,
        'run': handleTaskRun
    });
    var delay = _scheduler.milliseconds({time: instance.time, callable: instance.run});
    if(delay)
        _log_manager.create({message: "The task with uid: "+element+" is scheduled successfully.", date: new Date().toISOString(), type: "info"});
    else
        _log_manager.create({message: "The task with uid: "+element+" an error with the scheduling.", date: new Date().toISOString(), type: "error"});

});

function handleTaskStart(params){
    "use strict";
    var _date = new Date();
    _log_manager.create({message: "The task with uid: "+params.uid+"is completed.", date: params.date.toISOString(), type: "info"});
}

function handleTaskEnd(params){
    "use strict";
    var _date = new Date();
    _log_manager.create({message: "The task with uid: "+params.uid+"is completed.", date: date.toISOString(), type: "info"});
}

function handleTaskError(params){
    "use strict";
    _log_manager.create({message: "The task with uid: "+params.uid+" error execution:"+params.error, date: date.toISOString(), type: "error"});
}

function handleTaskCommunicate(params){
    "use strict";
    var options = {
        data: params.data,
        name: '',
        host: _global_config.host,
        port: _global_config.port,
        response: function(response){
            response.write('OK');
        }
    };
    _communication.request(options);
}

function handleTaskNotify(params){
    "use strict";

}

function handleTaskRun(params){
    "use strict";
    _scheduler.milliseconds({time: params.time, callable: params.callable, extra: params.extra});
}

//Handle the incoming request
function onIncomingRequest(request){
    var route = _route_manager['bot'].read({url: request.url, verb: request.method});
    
    if(route !== undefined){
        //var data = crypto.decrypt(request.body);
        //data = JSON.parse(data);
        var data = JSON.parse(request.body);
        switch (route.type){
            case 'task':
                doAction(route.verb, _task_loader, data);
                break;
            case 'config':
                break;
            case 'extra':
                doAction(route.verb, _log_manager, data);
                break;
        }
    }
    
}

function doAction(verb, manager, data){
    "use strict";
    switch(verb){
        case 'GET':
            manager.read(data);
            break;
        case 'PUT':
            manager.create(data);
            break;
        case 'PATCH':
            manager.update(data);
            break;
        case 'DELETE':
            manager.delete(data);
            break;
    }
}

//Outputs the response
function sendResponse(response){
    response.write('OK');
}