'use strict';

var fs    = require('fs');

var _self = {},
    _dir  = __dirname + '/../logs/',
    _logs = {};

function init(params){
    if(params !== undefined && params.dir !== undefined){
        _dir = params.dir;
    }

    if(loadLogs() !== undefined){
        return _self;
    }
}

function loadLogs(){
    try{
        _logs = JSON.parse(fs.readFileSync(_dir + 'logs.json'));
    }catch(ex){
        return;
    }

    return true;
}

function persistChanges(){
    try{
        fs.writeFileSync(_dir + 'logs.json', JSON.stringify(_logs));
    }catch(ex){
        return;
    }

    return true;
}

_self.create = function(params){
    if(params !== undefined && params.message !== undefined && params.date !== undefined && params.type !== undefined){
        if(_logs[params.type] !== undefined){
            var element = {
                "message" : params.message,
                "date"    : params.date
            };
            _logs[params.type].push(element);
            if(persistChanges() !== undefined){
                return element;
            }
        }
    }
};

_self.read = function(params){
    if(params !== undefined){
        if(params.type !== undefined){
            if(params.date === undefined){
                return _logs[params.type];
            }else{
                return filterLogsByDate(params.type, params.date, params.limit !== undefined ? params.limit : 10);
            }
        }
    }
};

function filterLogsByDate(type, date, limit){
    var logs = [];
    for(var i = _logs[type].length - 1 ; i >= 0; i--){
        if(_logs[type][i].date == date && logs.length <= limit)
            logs.push(_logs[type][i].date)
    }

    if(logs.length != 0)
        return logs;
}


module.exports = init;