'use strict';

var fs    = require('fs'),
	path  = require('path');

var _self = {},
	_dir  = __dirname + '/../config/routes/',
    _routes = {},
    _file;

function init(params){
    if(params !== undefined && params.file !== undefined){
        _file = params.file;
        if(params.dir !== undefined){
            _dir = params.dir;
        }

        if(loadFromConfigFile() !== undefined){
            return _self;
        }
    }
}

function loadFromConfigFile()
{
    //local server routes
    try{
        _routes = JSON.parse(fs.readFileSync(_dir + _file));
        //fs.readdirSync(_dir).forEach(function(element_file, index_file){
            //var loaded = JSON.parse(fs.readFileSync(_dir + 'bot.json'));
            /*for(var i = 0; i < loaded.length; i++){
                var type = loaded[i].type;
                var prefix = loaded[i].prefix;
                _routes[type] = [];
                for(var j = 0; j < loaded[i].actions.length; j++){
                    _routes[type].push(
                        {
                            'type'   : type,
                            'prefix' : prefix,
                            'uri'    : loaded[i].actions[j].uri,
                            'verb'   : loaded[i].actions[j].VERB,
                            'name'   : loaded[i].actions[j].name
                        }
                    );
                }
            }*/
        //});

        return true;
    }catch(ex){
        return;
    }

}

_self.create = function(params){
	if(params !== undefined && params.route !== undefined && params.file !== undefined){
        if(params.route.type !== undefined && params.route.prefix !== undefined && params.route.uri !== undefined && params.route.verb !== undefined && params.route.name !== undefined){
            if(_routes[params.route.type].isArray()){
                var element = {
                    'type'   : params.route.type,
                    'prefix' : params.route.prefix,
                    'uri'    : params.route.uri,
                    'verb'   : params.route.VERB,
                    'name'   : params.route.name
                };
                _routes[params.route.type].push(element);

                if(persistChanges() !== undefined){
                    return element;
                }
            }
        }
    }
};

_self.delete = function(params){
	if(params !== undefined && params.name !== undefined){
        if(params.type !== undefined){
            for(var i = 0 ; _routes[params.type].length ; i++){
                if(_routes[params.type][i].name == params.name){
                    var element = _routes[params.type].splice(i, 1);
                    if(persistChanges() !== undefined){
                        return element;
                    }
                }
            }
        }
    }
};

_self.update = function(params){
    if(params !== undefined && params.route !== undefined){
        if(params.route.type !== undefined && params.route.name !== undefined){
            for(var i = 0 ; _routes[params.route.type].length ; i++){
                if(_routes[params.route.type][i].name == params.route.name){
                    if(params.route.uri !== undefined)
                        _routes[params.route.type][i].uri = params.route.uri;
                    if(params.route.verb !== undefined)
                        _routes[params.route.type][i].verb = params.route.verb;
                    if(params.route.prefix !== undefined)
                        _routes[params.route.type][i].verb = params.route.verb;

                    if(persistChanges() !== true){
                        return _routes[params.route.type][i];
                    }
                }
            }
        }
    }
};

_self.read = function(params){
	if(params !== undefined && params.verb !== undefined && params.url !== undefined){
        for(var attr in _routes){
            var regex = new RegExp(attr);
            if(regex.test(params.url)){
                return matchRoute(params.url, attr, params.verb);
            }
        }
    }
};

function matchRoute(url, type, verb){
    for(var i = 0; i < _routes[type].length; i++){
        var pattern = '^\\/'+type+'\\/';
        if(_routes[type][i].uri.indexOf(':') > -1 )
            pattern += '[0-9]*$';
        else
            pattern += '$';
        var regex = new RegExp(pattern);
        if(regex.test(url) && _routes[type][i].verb == verb){
            return _routes[type][i];
        }
    }
}

function replaceWildcard(url){
    return url.substr(0, url.indexOf(':'));
}

function persistChanges(){
    try{
        fs.writeFileSync(_dir + _file, JSON.stringify(_routes));
    }catch(ex){
        return;
    }

    return true;
}

module.exports = init;