'use strict';

var fs    = require('fs'),
	path  = require('path');

var _self = {},
	_dir  = __dirname + '/../task/';

_self.create = function(params){
	if(params !== undefined && params.uid !== undefined && params.file !== undefined){
		try{
			fs.mkdirSync( path.normalize(_dir + params.uid) );
			//fs.writeFileSync( _dir + params.uid + '/route.js', params.file);
			if(params.config !== undefined){
				fs.writeFileSync( _dir + params.uid + '/config.js', params.config);
			}
			return {
				'uid'  : params.uid
			}
			
		}catch(ex){
			return;
		}
	}
	
	return;
};

_self.delete = function(params){
	if(params !== undefined && params.uid !== undefined){
        if(fs.readdirSync(_dir + params.uid).length >= 2){
            try{
                fs.readdirSync( _dir + params.uid).forEach(function(f){
                    fs.unlinkSync( _dir + params.uid + '/' + f );
                });

                fs.rmdirSync(_dir + params.uid);

                return true;
            }catch(ex){
                return;
            }
        }
	}
	
	return;
};

_self.update = function(params){
	if(params !== undefined && params.uid !== undefined){
		if(params.file !== undefined){
			fs.writeFileSync(_dir + params.uid + '/' + params.uid + '.js', params.file);
		}else if(params.config !== undefined){
			fs.writeFileSync(_dir + params.uid + '/config.json', params.config);
		}
		return true;
	}
	
	return;
};

_self.read = function(params){
    if(params === undefined){
        return fs.readdirSync(_dir);
    }else{
        if(params.uid !== undefined){
            if( fs.readdirSync(_dir + params.uid).length >= 2){
                return{
                    'path' : _dir + params.uid + '/',
                    'file' : params.uid + '.js',
                    'config': 'config.json'
                }
            }
        }
    }

    return;

};

function init(params){
	if(params !== undefined && params.dir !== undefined){
		_dir = params.dir;
	}
	
	return _self;
}

module.exports = init;