'use strict';

var fs      = require('fs'),
    http    = require('http');

var _self   = {},
    _routes = {};


function init(params){
    try{
        var file = __dirname+'/../config/routes/task_node.json';

        if(params !== undefined && params.route !== undefined)
            file = params.route;

        loadRoutes(JSON.parse(fs.readFileSync(file)));

        if(_routes)
            return _self;

    }catch(ex){
        return ex;
    }
}

function loadRoutes(params){
    if(params){
        for(var i = 0; i < params.task.length; i++){
            _routes[params.task[i].name] = {
                type : params.task[i].type,
                uri : params.task[i].uri,
                path : params.task[i].path,
                verb : params.task[i].verb
            }
        }
    }
}

_self.request = function(params){
    if(params && params.name && params.data && params.host && params.port && params.response){
        if(_routes[params.name]){
            http.request(
                {
                    host: params.host,
                    port: params.port,
                    path: _routes[name].path + _routes[name].uri,
                    method: _routes[name].verb
                },
                function(response){
                    var fullBody = '';

                    response.on('data', function(chunk){
                        fullBody += chunk.toString();
                    });

                    response.on('end', function(){
                        response.body = fullBody;
                        params.response(response);
                        response.end();
                    });
                }
            );
        }
    }
};

module.exports = init;